Subject: Re: forcedeth problems on 2.6.20-rc6-mm3

From: Andrew Morton <[email-masked]>
Date: Wed, 7 Feb 2007 21:33:38 -0800

On Mon, 5 Feb 2007 16:52:24 -0800 Andrew Morton <[email-masked]> wrote:

> On Mon, 05 Feb 2007 18:35:06 -0600
> Robert Hancock <[email-masked]> wrote:
> 
> > Daniel Barkalow wrote:
> > > On Sun, 4 Feb 2007, Robert Hancock wrote:
> > > 
> > >> Something's busted with forcedeth in 2.6.20-rc6-mm3 for me relative to
> > >> 2.6.20-rc6. There's no errors in dmesg, but it seems no packets ever get
> > >> received and so the machine can't get an IP address. I tried reverting all the
> > >> -mm changes to drivers/net/forcedeth.c, which didn't help. The network
> > >> controller shares an IRQ with the USB OHCI controller which is receiving
> > >> interrupts, so it doesn't seem like an interrupt routing problem, though I
> > >> suppose something wierd could be happening there.
> > > 
> > > IIRC, forcedeth tries to use MSI by default. Perhaps the hardware is using 
> > > it, but the kernel thinks enabling it didn't work? I think there's a 
> > > module option for forcedeth to disable MSI, which might be worth a try to 
> > > see if it has any effect.
> > 
> > I must have messed something up when testing before - reverting to 
> > forcedeth.c from 2.6.20-rc6 does indeed fix the problem. And it doesn't 
> > seem like no packets at all are received with the -mm3 version (driver 
> > version 0.60), either - if I do a tcpdump I can get Ethernet packets 
> > showing up, but I can't ping my router so it seems like something isn't 
> > getting through properly. With the 2.6.20-rc6 version (driver version 
> > 0.59) it works fine. I switched back and forth between versions and this 
> > seems repeatable.
> > 
> > I don't think it's MSI related, the CK804 version of these controllers 
> > doesn't support MSI and the driver shouldn't be trying to use it. I 
> > tried the MSI and MSI-X disable options on the 0.60 driver, but that 
> > didn't help.
> > 
> 
> OK, thanks.  Jeff, please note that the forcedeth changes in git-netdev-all
> have a problem.

Well all the forcedeth patches seems to have wandered into mainline anyway.

Please test current git (or tomorrow's git snapshot), see if it works?